Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.portal.resolver.atom
Interface AtomContentHandler

All Superinterfaces:
  org.xml.sax.ContentHandler, ResettableContentHandler

All Known Subinterfaces:
  DefaultAtomContentHandler, ResettableAtomContentHandler

All Known Implementing Classes:
  EmptyAtomContentHandler, LeafAtomContentHandler, ResettableAtomContentHandlerAdapter

    public interface AtomContentHandler

extends ResettableContentHandler

http://tools.ietf.org/html/rfc4287 RFC 4287

JAXP content handler extension that defines semantic callbacks for ATOM specific events. For each event in the ATOM namespace these semantic events should be called instead of the untyped SAX events. For all events outside of the ATOM namespace the methods on `ContentHandler` should be called.

From a design pattern, each ATOM element declares the attributes that are mentioned explicitly in the ATOM RFC 4287 as top level parameters. Common or extended attributes are transported via the `Attributes` interface. The naming convention `oXXX` indiciates an optional attribute that may be set to `null` whereas `rXXX` indicates a required attribute that must not be set to `null`.

Refer to the `Constants` interface for a list of ATOM releated constants (e.g. default values for attributes or namespaces, ...)

Since:
  6.0.1
See Also:
  `DefaultAtomContentHandler`, `Constants`

Method Summary
`void` | `endAuthor()` Indicates the end of an `atom:author` entry.
`void` | `endCategory()` Indicates the end of an `atom:category` entry.
`void` | `endContent()` Indicates the end of an `atom:content` entry.
`void` | `endContributor()` Indicates the end of an `atom:contributor` entry.
`void` | `endEMail()` Indicates the end of an `atom:email` entry.
`void` | `endEntry()` Indicates the end of an `atom:entry` entry.
`void` | `endFeed()` Indicates the end of an `atom:feed` entry.
`void` | `endGenerator()` Indicates the end of an `atom:generator` entry.
`void` | `endIcon()` Indicates the end of an `atom:icon` entry.
`void` | `endId()` Indicates the end of an `atom:id` entry.
`void` | `endLink()` Indicates the end of an `atom:link` entry.
`void` | `endLogo()` Indicates the end of an `atom:logo` entry.
`void` | `endName()` Indicates the end of an `atom:name` entry.
`void` | `endPublished()` Indicates the end of an `atom:published` entry.
`void` | `endRights()` Indicates the end of an `atom:rights` entry.
`void` | `endSource()` Indicates the end of an `atom:source` entry.
`void` | `endSubtitle()` Indicates the end of an `atom:subtitle` entry.
`void` | `endSummary()` Indicates the end of an `atom:summary` entry.
`void` | `endTitle()` Indicates the end of an `atom:title` entry.
`void` | `endUpdated()` Indicates the end of an `atom:updated` entry.
`void` | `endURI()` Indicates the end of an `atom:uri` entry.
`void` | `startAuthor(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:author` entry.
`void` | `startCategory(java.lang.String rTerm, java.lang.String oScheme, java.lang.String oLabel, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:category` entry.
`void` | `startContent(java.lang.String oType, java.lang.String oSrc, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:content` entry.
`void` | `startContributor(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:contributor` entry.
`void` | `startEMail(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:email` entry.
`void` | `startEntry(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:entry` entry.
`void` | `startFeed(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:feed` entry.
`void` | `startGenerator(java.lang.String oUri, java.lang.String oVersion, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:generator` entry.
`void` | `startIcon(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:icon` entry.
`void` | `startId(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:id` entry.
`void` | `startLink(java.lang.String rHref, java.lang.String oRel, java.lang.String oType, java.lang.String oHrefLang, java.lang.String oTitle, java.lang.String oLength, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:link` entry.
`void` | `startLogo(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:logo` entry.
`void` | `startName(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:name` entry.
`void` | `startPublished(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:published` entry.
`void` | `startRights(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:rights` entry.
`void` | `startSource(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:source` entry.
`void` | `startSubtitle(java.lang.String oType, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:subtitle` entry.
`void` | `startSummary(java.lang.String oType, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:summary` entry.
`void` | `startTitle(java.lang.String oType, org.xml.sax.Attributes attrs)` Indicates the start of an `atom:title` entry.
`void` | `startUpdated(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:updated` entry.
`void` | `startURI(org.xml.sax.Attributes attrs)` Indicates the start of an `atom:uri` entry.

Methods inherited from interface org.xml.sax.ContentHandler
`characters, endDocument, endElement, endPrefixMapping, ignorableWhitespace, processingInstruction, setDocumentLocator, skippedEntity, startDocument, startElement, startPrefixMapping`

Method Detail

### startFeed

    void startFeed(org.xml.sax.Attributes attrs)
                   throws org.xml.sax.SAXException

  Indicates the start of an `atom:feed` entry.

  The "atom:feed" element is the document (i.e., top-level) element of an Atom Feed Document, acting as a container for metadata and data associated with the feed. Its element children consist of metadata elements followed by zero or more atom:entry child elements.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endFeed

    void endFeed()
                 throws org.xml.sax.SAXException

  Indicates the end of an `atom:feed` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startEntry

    void startEntry(org.xml.sax.Attributes attrs)
                    throws org.xml.sax.SAXException

  Indicates the start of an `atom:entry` entry.

  The "atom:entry" element represents an individual entry, acting as a container for metadata and data associated with the entry. This element can appear as a child of the atom:feed element, or it can appear as the document (i.e., top-level) element of a stand-alone Atom Entry Document.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endEntry

    void endEntry()
                  throws org.xml.sax.SAXException

  Indicates the end of an `atom:entry` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startContent

    void startContent(java.lang.String oType,
                      java.lang.String oSrc,
                      org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

  Indicates the start of an `atom:content` entry.

  The "atom:content" element either contains or links to the content of the entry. The content of atom:content is Language-Sensitive.

  Parameters:
    `oType` - Optional type attribute, may be `null`.

    On the atom:content element, the value of the "type" attribute MAY be one of "text", "html", or "xhtml". Failing that, it MUST conform to the syntax of a MIME media type, but MUST NOT be a composite type (see Section 4.2.6 of [MIMEREG]). If neither the type attribute nor the src attribute is provided, Atom Processors MUST behave as though the type attribute were present with a value of "text".

    `oSrc` - Optional source attribute, may be `null`.

    atom:content MAY have a "src" attribute, whose value MUST be an IRI reference [RFC3987]. If the "src" attribute is present, atom:content MUST be empty. Atom Processors MAY use the IRI to retrieve the content and MAY choose to ignore remote content or to present it in a different manner than local content.

    If the "src" attribute is present, the "type" attribute SHOULD be provided and MUST be a MIME media type [MIMEREG], rather than "text", "html", or "xhtml". The value is advisory; that is to say, when the corresponding URI (mapped from an IRI, if necessary) is dereferenced, if the server providing that content also provides a media type, the server-provided media type is authoritative.

    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endContent

    void endContent()
                    throws org.xml.sax.SAXException

  Indicates the end of an `atom:content` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startAuthor

    void startAuthor(org.xml.sax.Attributes attrs)
                     throws org.xml.sax.SAXException

  Indicates the start of an `atom:author` entry.

  The "atom:author" element is a Person construct that indicates the author of the entry or feed

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endAuthor

    void endAuthor()
                   throws org.xml.sax.SAXException

  Indicates the end of an `atom:author` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startName

    void startName(org.xml.sax.Attributes attrs)
                   throws org.xml.sax.SAXException

  Indicates the start of an `atom:name` entry.

  The "atom:name" element's content conveys a human-readable name for the person. The content of atom:name is Language-Sensitive. Person constructs MUST contain exactly one "atom:name" element.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endName

    void endName()
                 throws org.xml.sax.SAXException

  Indicates the end of an `atom:name` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startURI

    void startURI(org.xml.sax.Attributes attrs)
                  throws org.xml.sax.SAXException

  Indicates the start of an `atom:uri` entry.

  The "atom:uri" element's content conveys an IRI associated with the person. Person constructs MAY contain an atom:uri element, but MUST NOT contain more than one. The content of atom:uri in a Person construct MUST be an IRI reference [RFC3987].

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endURI

    void endURI()
                throws org.xml.sax.SAXException

  Indicates the end of an `atom:uri` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startEMail

    void startEMail(org.xml.sax.Attributes attrs)
                    throws org.xml.sax.SAXException

  Indicates the start of an `atom:email` entry.

  The "atom:email" element's content conveys an e-mail address associated with the person. Person constructs MAY contain an atom:email element, but MUST NOT contain more than one. Its content MUST conform to the "addr-spec" production in [RFC2822].

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endEMail

    void endEMail()
                  throws org.xml.sax.SAXException

  Indicates the end of an `atom:email` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startCategory

    void startCategory(java.lang.String rTerm,
                       java.lang.String oScheme,
                       java.lang.String oLabel,
                       org.xml.sax.Attributes attrs)
                       throws org.xml.sax.SAXException

  Indicates the start of an `atom:category` entry.

  The "atom:category" element conveys information about a category associated with an entry or feed. This specification assigns no meaning to the content (if any) of this element.

  Parameters:
    `rTerm` - Mandatory term attribute, must not be `null`.

    The "term" attribute is a string that identifies the category to which the entry or feed belongs. Category elements MUST have a "term" attribute.

    `oScheme` - Optional scheme attribute, may be `null`.

    The "scheme" attribute is an IRI that identifies a categorization scheme. Category elements MAY have a "scheme" attribute.

    `oLabel` - Optional label attribute, may be `null`.

    The "label" attribute provides a human-readable label for display in end-user applications. The content of the "label" attribute is Language-Sensitive. Entities such as "&amp;" and &lt;" represent their corresponding characters ("&" and "<", respectively), not markup. Category elements MAY have a "label" attribute.

    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endCategory

    void endCategory()
                     throws org.xml.sax.SAXException

  Indicates the end of an `atom:category` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startContributor

    void startContributor(org.xml.sax.Attributes attrs)
                          throws org.xml.sax.SAXException

  Indicates the start of an `atom:contributor` entry.

  The "atom:contributor" element is a Person construct that indicates a person or other entity who contributed to the entry or feed.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endContributor

    void endContributor()
                        throws org.xml.sax.SAXException

  Indicates the end of an `atom:contributor` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startGenerator

    void startGenerator(java.lang.String oUri,
                        java.lang.String oVersion,
                        org.xml.sax.Attributes attrs)
                        throws org.xml.sax.SAXException

  Indicates the start of an `atom:generator` entry.

  The "atom:generator" element's content identifies the agent used to generate a feed, for debugging and other purposes.

  Parameters:
    `oUri` - Optional uri attribute, may be `null`.

    The atom:generator element MAY have a "uri" attribute whose value MUST be an IRI reference [RFC3987]. When dereferenced, the resulting URI (mapped from an IRI, if necessary) SHOULD produce a representation that is relevant to that agent.

    `oVersion` - Optional version attribute, may be `null`.

    The atom:generator element MAY have a "version" attribute that indicates the version of the generating agent.

    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endGenerator

    void endGenerator()
                      throws org.xml.sax.SAXException

  Indicates the end of an `atom:generator` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startIcon

    void startIcon(org.xml.sax.Attributes attrs)
                   throws org.xml.sax.SAXException

  Indicates the start of an `atom:icon` entry.

  The "atom:icon" element's content is an IRI reference [RFC3987] that identifies an image that provides iconic visual identification for a feed.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endIcon

    void endIcon()
                 throws org.xml.sax.SAXException

  Indicates the end of an `atom:icon` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startId

    void startId(org.xml.sax.Attributes attrs)
                 throws org.xml.sax.SAXException

  Indicates the start of an `atom:id` entry.

  The "atom:id" element conveys a permanent, universally unique identifier for an entry or feed. Its content MUST be an IRI, as defined by [RFC3987]. Note that the definition of "IRI" excludes relative references. Though the IRI might use a dereferencable scheme, Atom Processors MUST NOT assume it can be dereferenced.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endId

    void endId()
               throws org.xml.sax.SAXException

  Indicates the end of an `atom:id` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startLink

    void startLink(java.lang.String rHref,
                   java.lang.String oRel,
                   java.lang.String oType,
                   java.lang.String oHrefLang,
                   java.lang.String oTitle,
                   java.lang.String oLength,
                   org.xml.sax.Attributes attrs)
                   throws org.xml.sax.SAXException

  Indicates the start of an `atom:link` entry.

  The "atom:link" element defines a reference from an entry or feed to a Web resource. This specification assigns no meaning to the content (if any) of this element.

  Parameters:
    `rHref` - Mandatory href attribute, must not be `null`.

    The "href" attribute contains the link's IRI. atom:link elements MUST have an href attribute, whose value MUST be a IRI reference [RFC3987].

    `oRel` - Optional rel attribute, may be `null`.

    atom:link elements MAY have a "rel" attribute that indicates the link relation type. If the "rel" attribute is not present, the link element MUST be interpreted as if the link relation type is "alternate".

    The value of "rel" MUST be a string that is non-empty and matches either the "isegment-nz-nc" or the "IRI" production in [RFC3987]. Note that use of a relative reference other than a simple name is not allowed. If a name is given, implementations MUST consider the link relation type equivalent to the same name registered within the IANA

    `oType` - Optional type attribute, may be `null`.

    On the link element, the "type" attribute's value is an advisory media type: it is a hint about the type of the representation that is expected to be returned when the value of the href attribute is dereferenced. Note that the type attribute does not override the actual media type returned with the representation. Link elements MAY have a type attribute, whose value MUST conform to the syntax of a MIME media type [MIMEREG].

    `oHrefLang` - Optional hreflang attribute, may be `null`.

    The "hreflang" attribute's content describes the language of the resource pointed to by the href attribute. When used together with the rel="alternate", it implies a translated version of the entry. Link elements MAY have an hreflang attribute, whose value MUST be a language tag [RFC3066].

    `oTitle` - Optional title attribute, may be `null`.

    The "title" attribute conveys human-readable information about the link. The content of the "title" attribute is Language-Sensitive. Entities such as "&" and "<" represent their corresponding characters ("&" and "<", respectively), not markup. Link elements MAY have a title attribute.

    `oLength` - Optional length attribute, may be `null`.

    The "length" attribute indicates an advisory length of the linked content in octets; it is a hint about the content length of the representation returned when the IRI in the href attribute is mapped to a URI and dereferenced. Note that the length attribute does not override the actual content length of the representation as reported by the underlying protocol. Link elements MAY have a length attribute.

    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endLink

    void endLink()
                 throws org.xml.sax.SAXException

  Indicates the end of an `atom:link` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startLogo

    void startLogo(org.xml.sax.Attributes attrs)
                   throws org.xml.sax.SAXException

  Indicates the start of an `atom:logo` entry.

  The "atom:logo" element's content is an IRI reference [RFC3987] that identifies an image that provides visual identification for a feed.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endLogo

    void endLogo()
                 throws org.xml.sax.SAXException

  Indicates the end of an `atom:logo` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startRights

    void startRights(org.xml.sax.Attributes attrs)
                     throws org.xml.sax.SAXException

  Indicates the start of an `atom:rights` entry.

  The "atom:rights" element is a Text construct that conveys information about rights held in and over an entry or feed.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endRights

    void endRights()
                   throws org.xml.sax.SAXException

  Indicates the end of an `atom:rights` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startSource

    void startSource(org.xml.sax.Attributes attrs)
                     throws org.xml.sax.SAXException

  Indicates the start of an `atom:source` entry.

  If an atom:entry is copied from one feed into another feed, then the source atom:feed's metadata (all child elements of atom:feed other than the atom:entry elements) MAY be preserved within the copied entry by adding an atom:source child element, if it is not already present in the entry, and including some or all of the source feed's Metadata elements as the atom:source element's children. Such metadata SHOULD be preserved if the source atom:feed contains any of the child elements atom:author, atom:contributor, atom:rights, or atom:category and those child elements are not present in the source atom:entry.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endSource

    void endSource()
                   throws org.xml.sax.SAXException

  Indicates the end of an `atom:source` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startSubtitle

    void startSubtitle(java.lang.String oType,
                       org.xml.sax.Attributes attrs)
                       throws org.xml.sax.SAXException

  Indicates the start of an `atom:subtitle` entry.

  The "atom:subtitle" element is a Text construct that conveys a human- readable description or subtitle for a feed.

  Parameters:
    `oType` - Optional type attribute, may be `null`.
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endSubtitle

    void endSubtitle()
                     throws org.xml.sax.SAXException

  Indicates the end of an `atom:subtitle` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startSummary

    void startSummary(java.lang.String oType,
                      org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

  Indicates the start of an `atom:summary` entry.

  The "atom:summary" element is a Text construct that conveys a short summary, abstract, or excerpt of an entry.

  Parameters:
    `oType` - Optional type attribute, may be `null`.
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endSummary

    void endSummary()
                    throws org.xml.sax.SAXException

  Indicates the end of an `atom:summary` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startTitle

    void startTitle(java.lang.String oType,
                    org.xml.sax.Attributes attrs)
                    throws org.xml.sax.SAXException

  Indicates the start of an `atom:title` entry.

  The "atom:title" element is a Text construct that conveys a human- readable title for an entry or feed.

  Parameters:
    `oType` - Optional type attribute, may be `null`.
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endTitle

    void endTitle()
                  throws org.xml.sax.SAXException

  Indicates the end of an `atom:title` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startUpdated

    void startUpdated(org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

  Indicates the start of an `atom:updated` entry.

  The "atom:updated" element is a Date construct indicating the most recent instant in time when an entry or feed was modified in a way the publisher considers significant. Therefore, not all modifications necessarily result in a changed atom:updated value.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endUpdated

    void endUpdated()
                    throws org.xml.sax.SAXException

  Indicates the end of an `atom:updated` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### startPublished

    void startPublished(org.xml.sax.Attributes attrs)
                        throws org.xml.sax.SAXException

  Indicates the start of an `atom:published` entry.

  The "atom:published" element is a Date construct indicating an instant in time associated with an event early in the life cycle of the entry.

  Parameters:
    `attrs` - optional attribues, must not be `null` but may be empty
  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

### endPublished

    void endPublished()
                      throws org.xml.sax.SAXException

  Indicates the end of an `atom:published` entry.

  Throws:
    `org.xml.sax.SAXException` - - if the event could not be created

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD